void controllerSetup() {
  cp5 = new ControlP5(this);

  ControlFont labelFont = new ControlFont(fonts[0], 16);
  ControlFont valueFont = new ControlFont(fonts[1], 12);

  l = cp5.addListBox("myList")
    .setPosition(width/16, height/2 + 150)
    .setSize(width/4-width/16, 3*height/8 - 150)
    .setItemHeight(15)
    .setBarHeight(15)
    .setColorBackground(colors[9])
    .setColorActive(colors[8])
    .setColorForeground(0xFFEB6002)
    ;
  l.getCaptionLabel().toUpperCase(true);
  l.getCaptionLabel().set("Item | Moments");
  l.getCaptionLabel().setColor(colors[8]);
  l.getCaptionLabel().setFont(labelFont);
  l.getCaptionLabel().getStyle().marginTop= 5;
  l.getCaptionLabel().getStyle().marginLeft= -5;
  l.getValueLabel().setColor(colors[9]);
  l.getValueLabel().setFont(valueFont);
  l.getValueLabel().getStyle().marginTop= 5;
  l.getValueLabel().getStyle().marginLeft= -5;
  for (int i=0; i<rowNums; i++) {
    String title = nf(i, 3)+" "+ dataTable.getRow(i).getString(0);
    int maxLength = int((width/4-width/16)/7);
    if (title.length()>maxLength) title= title.substring(0, maxLength);
    l.addItem(title, i);
    CColor c = new CColor();
    c.setBackground(colors[8]);
    l.getItem(title).put("color", c);
    //println(l.getItem(title));
  }
  cp5.setAutoDraw(false);
}

void gui() {

  cp5.draw();

  float horizonalLocation = width/16;
  float verticalLocation = height/2;
  //float dist = 25;

  //fill(128, 30);
  fill(128, 0);   //the left bottom table background translucent 
  noStroke();
  rectMode(CORNER);
  //rect(width/32, height/16, width/4, height/8);
  rect(width/32, height/2-height/16, width/4, height/2);

  boolean isMouseInX = (mouseX > width/32) && (mouseX<(width/4+width/32));
  boolean isMouseInY = (mouseY > (height/2-height/16)) && (mouseY <(height-height/16));
  boolean isMouseIn = isMouseInX && isMouseInY;

  if (isMouseIn||interactWithCate) cam.setActive(false);
  else cam.setActive(true);

  // 
  // Title of the project
  //
  fill(colors[1], 200);
  textFont(fonts[0], 40);
  textAlign(LEFT, BOTTOM);
  text("The Pursuit of Happiness", horizonalLocation, height/8 - 15);
  textFont(fonts[0], 38);
  textAlign(LEFT, TOP);
  text("7 Categories of What Makes You Happy", horizonalLocation, height/8);

  textSize(24);
  textAlign(LEFT, TOP);
  text("MAT 259A | April Cai", horizonalLocation, height/8 + 50);
  
  //
  //interactive print keys
  //
  textSize(20);
  textAlign(LEFT, TOP);
  text("press 1   | Center view", horizonalLocation, height/8 + 80);
  text("press 2   | 90 degree view", horizonalLocation, height/8 + 100);
  text("press 3   | Side view", horizonalLocation, height/8 + 120);
  text("press S   | Save the frame", horizonalLocation, height/8 + 140);
  text("press T   | Make it spin", horizonalLocation, height/8 + 160);   
   
  // 
  // draw text
  //
  textAlign(LEFT, TOP);
  if (presentYear == 2017) {
      if (mousePressed) fill(colors[9], 200);
      else fill(colors[9], 200);
      textFont(fonts[0], 34);
      text("HappyDB: ", horizonalLocation, verticalLocation - 24);
      textFont(fonts[0], 24);
      text("A Corpus of 100,000", horizonalLocation, verticalLocation + 12);
      text("Crowdsourced ", horizonalLocation, verticalLocation + 40);
      text("Happy Moments in Year ", horizonalLocation, verticalLocation + 70);
      textFont(fonts[0], 34);
      text(str(presentYear), horizonalLocation, verticalLocation + 100);
    }
    
  // -------------------------------------------------------------- //
  // Sevent small triangles for iteractions
  // (Mouse location judgement is in Interaction.pde)
  // (1) Seven triangles
  //
  pushMatrix();
  translate(width*7/8, height*13/16);
  //beginShape(LINES);
  beginShape();
  for (int i = 0; i< 7; i++) {
    PVector p1 = PVector.lerp(Points[i], Points[(i+1)%7], 0.1);
    PVector p2 = PVector.lerp(Points[i], Points[(i+1)%7], 0.9);
    //println(p1);
    strokeWeight(3);
    if (mouseOnCate[i]) {
      if (mousePressed) stroke(colors[i], 255);
      else stroke(colors[i], 100);
    } else {
      if (showTheCate[i]) stroke(colors[i], 255);
      else stroke(colors[i], 20);
    }
    noFill();
    vertex(0,0,0);
    vertex(p1.x/5, p1.y/5, 0);
    vertex(p2.x/5, p2.y/5, 0);
  }
  vertex(0,0,0);
  endShape();

  // (2) Seven triangles' text labels
  //
  for (int i = 0; i< 7; i++) {
    PVector p3 = PVector.lerp(Points[i], Points[(i+1)%7], 0.5);
    pushMatrix();
    translate(p3.x/5*1.1, p3.y/5*1.1);
    rotate((i+0.5)*2*PI/7+PI/2);
    fill(colors[9], 200);
    textAlign(CENTER, BOTTOM);
    textFont(fonts[0], 12);
    text(sevenCate [i], 0, 0);
    popMatrix();
  }
  popMatrix();
}

 
  